
__Init:

;CODE.c,33 :: 		void _Init()
;CODE.c,35 :: 		trisd.f0=0;
	BCF        TRISD+0, 0
;CODE.c,36 :: 		lcd_init();
	CALL       _Lcd_Init+0
;CODE.c,37 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;CODE.c,38 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;CODE.c,41 :: 		intcon.f7=1;   //enable global interrupt
	BSF        INTCON+0, 7
;CODE.c,42 :: 		intcon.f6=1;  //enable pref interrupt
	BSF        INTCON+0, 6
;CODE.c,43 :: 		intcon.f5=1; //timer0 overflow interrupt
	BSF        INTCON+0, 5
;CODE.c,44 :: 		OPTION_REG.T0CS = 0; //Internal instruction cycle clock
	BCF        OPTION_REG+0, 5
;CODE.c,45 :: 		OPTION_REG.PSA = 0;  //0 = Prescaler is assigned to the Timer0 module
	BCF        OPTION_REG+0, 3
;CODE.c,46 :: 		OPTION_REG.PS2 = 1; OPTION_REG.PS1 = 1; OPTION_REG.PS0 = 1;  //prescalar is set to 256
	BSF        OPTION_REG+0, 2
	BSF        OPTION_REG+0, 1
	BSF        OPTION_REG+0, 0
;CODE.c,47 :: 		tmr0_cnt=100;
	MOVLW      100
	MOVWF      _tmr0_cnt+0
;CODE.c,48 :: 		tmr0=139; //Timer0 starts counting from 98(TMR0 Preload)
	MOVLW      139
	MOVWF      TMR0+0
;CODE.c,52 :: 		PIE1.f0=1; //Enables the TMR1 overflow interrupt
	BSF        PIE1+0, 0
;CODE.c,53 :: 		t1con.f1=1; //External clock (on the rising edge)
	BSF        T1CON+0, 1
;CODE.c,54 :: 		t1con.f3=1; //Oscillator is shut-off
	BSF        T1CON+0, 3
;CODE.c,55 :: 		t1con.f2=1; //Synchronize external clock input
	BSF        T1CON+0, 2
;CODE.c,56 :: 		tmr1l=0; tmr1h=0; //clear timer1
	CLRF       TMR1L+0
	CLRF       TMR1H+0
;CODE.c,57 :: 		}
L_end__Init:
	RETURN
; end of __Init

_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;CODE.c,61 :: 		void interrupt()
;CODE.c,64 :: 		if(intcon.f2==1) //if timer0 is overlfowed
	BTFSS      INTCON+0, 2
	GOTO       L_interrupt0
;CODE.c,66 :: 		if(tmr0_cnt--==1) //decrement and check tmr0_cnt until zer0 which means a second
	MOVF       _tmr0_cnt+0, 0
	MOVWF      R1+0
	DECF       _tmr0_cnt+0, 1
	MOVF       R1+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_interrupt1
;CODE.c,67 :: 		{   portb.f0= ~portb.f0;
	MOVLW      1
	XORWF      PORTB+0, 1
;CODE.c,68 :: 		intcon.f7=0; t1con.f0=0;  //stop counting and global interrupts
	BCF        INTCON+0, 7
	BCF        T1CON+0, 0
;CODE.c,69 :: 		flag=1;  //set flag
	BSF        _flag+0, BitPos(_flag+0)
;CODE.c,70 :: 		}
L_interrupt1:
;CODE.c,72 :: 		intcon.f2=0; //reset timer0 flag
	BCF        INTCON+0, 2
;CODE.c,73 :: 		tmr0=139;  //Timer0 starts counting from 98 again
	MOVLW      139
	MOVWF      TMR0+0
;CODE.c,74 :: 		}
L_interrupt0:
;CODE.c,76 :: 		if(pir1.f0==1) //if timer1 is overlfowed
	BTFSS      PIR1+0, 0
	GOTO       L_interrupt2
;CODE.c,78 :: 		OverNumb++;  //increment number of overflow
	INCF       _OverNumb+0, 1
	BTFSC      STATUS+0, 2
	INCF       _OverNumb+1, 1
;CODE.c,79 :: 		pir1.f0=0; //reset timer1 flag
	BCF        PIR1+0, 0
;CODE.c,80 :: 		}
L_interrupt2:
;CODE.c,82 :: 		}
L_end_interrupt:
L__interrupt9:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_main:

;CODE.c,87 :: 		void main()
;CODE.c,88 :: 		{   trisb=0;
	CLRF       TRISB+0
;CODE.c,89 :: 		portb=0x00;
	CLRF       PORTB+0
;CODE.c,90 :: 		_Init();
	CALL       __Init+0
;CODE.c,92 :: 		lcd_out(1,1, "FrequencyMeter");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_CODE+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;CODE.c,93 :: 		for(;;)
L_main3:
;CODE.c,95 :: 		if(flag==1) //if one second elapsed
	BTFSS      _flag+0, BitPos(_flag+0)
	GOTO       L_main6
;CODE.c,97 :: 		tmr1_Val = (TMR1H << 8) + TMR1L; //get high and low from timer1
	MOVF       TMR1H+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       TMR1L+0, 0
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
	MOVF       R0+0, 0
	MOVWF      _tmr1_Val+0
	MOVF       R0+1, 0
	MOVWF      _tmr1_Val+1
;CODE.c,98 :: 		Freq =  tmr1_Val;  //calculate frequency
	MOVF       R0+0, 0
	MOVWF      _Freq+0
	MOVF       R0+1, 0
	MOVWF      _Freq+1
	CLRF       _Freq+2
	CLRF       _Freq+3
;CODE.c,99 :: 		LongWordToStr(Freq,Freq_txt); //convert Frequency to string
	MOVF       _Freq+0, 0
	MOVWF      FARG_LongWordToStr_input+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_LongWordToStr_input+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_LongWordToStr_input+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_LongWordToStr_input+3
	MOVLW      _Freq_txt+0
	MOVWF      FARG_LongWordToStr_output+0
	CALL       _LongWordToStr+0
;CODE.c,100 :: 		floatToStr(TPer,TPer_txt);   //convert Period to string
	MOVF       _TPer+0, 0
	MOVWF      FARG_FloatToStr_fnum+0
	MOVF       _TPer+1, 0
	MOVWF      FARG_FloatToStr_fnum+1
	MOVF       _TPer+2, 0
	MOVWF      FARG_FloatToStr_fnum+2
	MOVF       _TPer+3, 0
	MOVWF      FARG_FloatToStr_fnum+3
	MOVLW      _TPer_txt+0
	MOVWF      FARG_FloatToStr_str+0
	CALL       _FloatToStr+0
;CODE.c,101 :: 		lcd_out(2,1, Freq_txt); lcd_out_cp("Hz");  //display Frequency
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _Freq_txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
	MOVLW      ?lstr2_CODE+0
	MOVWF      FARG_Lcd_Out_CP_text+0
	CALL       _Lcd_Out_CP+0
;CODE.c,102 :: 		tmr1l=0; tmr1h=0; tmr1_Val=0;  OverNumb=0; Freq=0; TPer=0; //reset variables
	CLRF       TMR1L+0
	CLRF       TMR1H+0
	CLRF       _tmr1_Val+0
	CLRF       _tmr1_Val+1
	CLRF       _OverNumb+0
	CLRF       _OverNumb+1
	CLRF       _Freq+0
	CLRF       _Freq+1
	CLRF       _Freq+2
	CLRF       _Freq+3
	CLRF       _TPer+0
	CLRF       _TPer+1
	CLRF       _TPer+2
	CLRF       _TPer+3
;CODE.c,103 :: 		tmr0_cnt=100; flag=0; //reset variables
	MOVLW      100
	MOVWF      _tmr0_cnt+0
	BCF        _flag+0, BitPos(_flag+0)
;CODE.c,105 :: 		intcon.f7=1; t1con.f0=1;  //reenabling counting and global interrupts
	BSF        INTCON+0, 7
	BSF        T1CON+0, 0
;CODE.c,106 :: 		}
L_main6:
;CODE.c,107 :: 		}
	GOTO       L_main3
;CODE.c,108 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
